// NOTE: [This JS must loaded as last item]


	// ===============================================================
	// Initialize Form
	// ===============================================================
	function FORM_LOAD()
	{
		// Initialize
		// _______________________________________________________________________	
		var DGV_ELEMENT_CHILD = null;
		var DGV_ELEMENT_CHILD_INDEX = 0;
		
		
		// Load DataGridVuew
		// _______________________________________________________________________	
		POS_RETURN_LIST_DGV = DataGridView("POS_RETURN_LIST_DGV");
		//POS_RETURN_LIST_DGV.SETTING_ALLOW_USER_TO_ADD_ROWS = true;
		//POS_RETURN_LIST_DGV.SETTING_EDITABLE = true;
		POS_RETURN_LIST_DGV.ON_CLICK
		(			
			function(COL_INDEX, ROW_INDEX)
			{
				// Delete Button
				// ...........................................
				if(POS_RETURN_LIST_DGV.COLUMN.NAME(COL_INDEX) == "DELETE_CMD")
				{
					// Delete Unsaved Item
					if
					(
						POS_RETURN_LIST_DGV.COLUMN.IS_EXISTS("REC_POSRETURN_LIST_ID") &&
						JSVC_NUM.VAR_NVALL(POS_RETURN_LIST_DGV.CELL.VALUE("REC_POSRETURN_LIST_ID", ROW_INDEX)) <= 0
					)
					{
						POS_RETURN_LIST_DGV.ROW.REMOVE_AT(ROW_INDEX);
					}
					
					// Delete Saved Item
					else
					{
						HTTP_DELETE
						(
							function(IS_SUCCESS)
							{
								console.log('Record Deleted.');
							}, 
							ROW_INDEX
						);				
					}
				}			

				// Void Button
				// ...........................................
				else if(POS_RETURN_LIST_DGV.COLUMN.NAME(COL_INDEX) == "VOID_CMD")
				{
					// Delete Unsaved Item
					if
					(
						POS_RETURN_LIST_DGV.COLUMN.IS_EXISTS("REC_POSRETURN_LIST_ID") &&
						JSVC_NUM.VAR_NVALL(POS_RETURN_LIST_DGV.CELL.VALUE("REC_POSRETURN_LIST_ID", ROW_INDEX)) <= 0
					)
					{
						POS_RETURN_LIST_DGV.ROW.REMOVE_AT(ROW_INDEX);
					}
					
					// Void Saved Item
					else
					{

					}
				}	
				
				// Link to Child Table
				// ...........................................
				/*
				// Sample Child Code
				else if(POS_RETURN_LIST_DGV.COLUMN.NAME(COL_INDEX) == "CHILD_CMD")
				{
					// Get Current Root path
					var CURRENT_ROOT_PATH = JSCUS_CACHE.ROOT_PATH + JSVC_STR.VAR_MID(JSVC_STR.VAR_DLEFT(JSCUS_CACHE.AUTH_REDIRECT_URL[JSCUS_CACHE.LOGIN_CLASS], JSCUS_CACHE.SERVER_URL.length), 1, 1);
			
					// Cache Primary Key
					JSVC_COOKIE.VAR_ADD
					(
						'PROPERTY_PARENT_ID', 
						POS_RETURN_LIST_DGV.CELL.VALUE('REC_POSRETURN_LIST_ID', ROW_INDEX), 
						5, 
						CURRENT_ROOT_PATH
					);
					JSVC_COOKIE.VAR_ADD
					(
						'PROPERTY_PARENT_DESCRIPTION', 
						POS_RETURN_LIST_DGV.CELL.VALUE('REC_POSRETURN_LIST_ID', ROW_INDEX), 
						5, 
						CURRENT_ROOT_PATH
					);
					
					// Open EditPage
					window.location = JSCUS_CACHE.SERVER_URL + '/p/record/pos_return_list.html';	
					return;
				}
				*/
						
	
				// If dialog supported
				// ...........................................
				else if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("POS_RETURN_LIST_MODAL") == true)
				{
					// Clear Modal
					if(JSVC_VAR.VAR_ISSET(INPUT_INSTANCE))
					{
						JSOC_WINDOW.VAR_INPUT_INSTANCE_RESTORE(INPUT_INSTANCE);
					}
						
					// Display Modal
					PROPERTY_REC_POSRETURN_LIST_ID = POS_RETURN_LIST_DGV.CELL.VALUE('REC_POSRETURN_LIST_ID', ROW_INDEX);
					PROPERTY_EDIT_ROW_INDEX = ROW_INDEX;
					
					EDIT_HANDLER.REF_IS_MODIFIED = false;
					JSOC_DIALOG.VAR_MODAL("POS_RETURN_LIST_MODAL", true);
					HTTP_LOAD();
					return;
				}
				
				// Open View / Edit Page
				// ...........................................
				else if(POS_RETURN_LIST_DGV.SETTING_EDITABLE == false)
				{
					// Get Current Root path
					var CURRENT_ROOT_PATH = JSCUS_CACHE.ROOT_PATH + JSVC_STR.VAR_MID(JSVC_STR.VAR_DLEFT(JSCUS_CACHE.AUTH_REDIRECT_URL[JSCUS_CACHE.LOGIN_CLASS], JSCUS_CACHE.SERVER_URL.length), 1, 1);

					
							
					// Cache Primary Key
					JSVC_COOKIE.VAR_ADD
					(
						'PROPERTY_PARENT_ID', 
						POS_RETURN_LIST_DGV.CELL.VALUE('REC_POSRETURN_LIST_ID', ROW_INDEX), 
						5, 
						CURRENT_ROOT_PATH
					);
					JSVC_COOKIE.VAR_ADD
					(
						'PROPERTY_PARENT_DESCRIPTION', 
						POS_RETURN_LIST_DGV.CELL.VALUE('REC_POSRETURN_LIST_ID', ROW_INDEX), 
						5, 
						CURRENT_ROOT_PATH
					);
					
					// Open EditPage
					window.location = 'pos_return_list_info.html';				
				}

			}
		);   

		
		// Show Progress
		// _______________________________________________________________________	
		JSOC_DIALOG.VAR_LOADING_SPINNER(true);
		
		
		// Requires Authentication
		// _______________________________________________________________________	
		PAGE_AUTH_REQUIRES_LOGIN(HTTP_POPULATE_RESULT);			


		
		
		// Foreign Key [Fixed]
		// _______________________________________________________________________	
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB") == true)
		{
			// Set Default Item, if used in DataGridView
			JSOC_CMB.VAR_ADD("REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB", FLAG_BIGINT_NULL.toString(), "-");
			// To use custom populate
			// var GET_MAP_ARRAY = JSCUS_SQL._RECORD._POS_RETURN.CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			// JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_', JSCUS_SQL._SYSTEM._STATUS.STATUS_ACTIVE);	
			JSCUS_SQL._RECORD._POS_RETURN.CUS_GET_THEN_POPULATE_COMBOBOX
			(
				function()
				{
					// Set Default index
					JSOC_CMB.VAR_SELECTED_INDEX("REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB", 0);
					
					// Clone to DGV Cell if ComboBox Exists
					if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("POS_RETURN_LIST_DGV_ROW_REC_POSRETURN_LIST_REC_POSRETURN_ID") == true)
					{
						DGV_ELEMENT_CHILD = JSOC_ELEMENT.VAR_SUB_ELEMENTS("POS_RETURN_LIST_DGV_ROW_REC_POSRETURN_LIST_REC_POSRETURN_ID");
						DGV_ELEMENT_CHILD_INDEX = 0;
						while(DGV_ELEMENT_CHILD.length > DGV_ELEMENT_CHILD_INDEX)
						{
							if
							(
								DGV_ELEMENT_CHILD[DGV_ELEMENT_CHILD_INDEX].tagName == "SELECT" &&
								JSVC_STR.VAR_IS_BLANK(DGV_ELEMENT_CHILD[DGV_ELEMENT_CHILD_INDEX].id.toString())
							)
							{
								JSOC_ELEMENT.VAR_INNER_HTML
								(
									DGV_ELEMENT_CHILD[DGV_ELEMENT_CHILD_INDEX], 
									JSOC_ELEMENT.VAR_INNER_HTML("REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB")
								);
							}	
							DGV_ELEMENT_CHILD_INDEX ++;
						}
					}
					
					// Copy items to edit control
					if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB") == true)
					{
						JSOC_CMB.VAR_CLEAR("SEARCH_REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB");
						JSOC_CMB.VAR_ADD("SEARCH_REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB", FLAG_BIGINT_NULL.toString(),"Any Pos_Return");
						JSOC_ELEMENT.VAR_INNER_HTML("SEARCH_REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB", JSOC_ELEMENT.VAR_INNER_HTML("REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB"), true);
						JSOC_CMB.VAR_SELECTED_INDEX("SEARCH_REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB", 0);
						$('.BSSP_SEARCH_REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB').selectpicker('refresh');
					}				
					
					// Update Modal Settings
					if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("POS_RETURN_LIST_MODAL") == true)
					{
						INPUT_INSTANCE = JSOC_WINDOW.VAR_INPUT_INSTANCE_CLONE("POS_RETURN_LIST_MODAL");
					}
					
					// Forward populate complete event.
					$('.BSSP_REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB').selectpicker('refresh');
					HTTP_POPULATE_RESULT();		
				},
				"REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB",
				false, 2
				// , GET_MAP_ARRAY 
			);
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB") == true &&
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB") == false
		)
		{
			JSOC_CMB.VAR_CLEAR("SEARCH_REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB");
			JSOC_CMB.VAR_ADD("SEARCH_REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB", FLAG_BIGINT_NULL.toString(),"Any Pos_Return");
			// To use custom populate
			// var GET_MAP_ARRAY = JSCUS_SQL._RECORD._POS_RETURN.CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			// JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_', JSCUS_SQL._SYSTEM._STATUS.STATUS_ACTIVE);	
			JSCUS_SQL._RECORD._POS_RETURN.CUS_GET_THEN_POPULATE_COMBOBOX
			(
				function()
				{
					// Set Default index
					JSOC_CMB.VAR_SELECTED_INDEX("SEARCH_REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB", 0);
					
					// Forward populate complete event.		
					$('.BSSP_SEARCH_REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB').selectpicker('refresh');
					HTTP_POPULATE_RESULT();
				},		
				"SEARCH_REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB",
				true, 2
				// , GET_MAP_ARRAY 
			);
		}
		
		// Foreign Key [Fixed]
		// _______________________________________________________________________	
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB") == true)
		{
			// Set Default Item, if used in DataGridView
			JSOC_CMB.VAR_ADD("REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB", FLAG_BIGINT_NULL.toString(), "-");
			// To use custom populate
			// var GET_MAP_ARRAY = JSCUS_SQL._RECORD._POS_SALE_LIST.CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			// JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_', JSCUS_SQL._SYSTEM._STATUS.STATUS_ACTIVE);	
			JSCUS_SQL._RECORD._POS_SALE_LIST.CUS_GET_THEN_POPULATE_COMBOBOX
			(
				function()
				{
					// Set Default index
					JSOC_CMB.VAR_SELECTED_INDEX("REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB", 0);
					
					// Clone to DGV Cell if ComboBox Exists
					if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("POS_RETURN_LIST_DGV_ROW_REC_POSRETURN_LIST_REC_POSSALE_LIST_ID") == true)
					{
						DGV_ELEMENT_CHILD = JSOC_ELEMENT.VAR_SUB_ELEMENTS("POS_RETURN_LIST_DGV_ROW_REC_POSRETURN_LIST_REC_POSSALE_LIST_ID");
						DGV_ELEMENT_CHILD_INDEX = 0;
						while(DGV_ELEMENT_CHILD.length > DGV_ELEMENT_CHILD_INDEX)
						{
							if
							(
								DGV_ELEMENT_CHILD[DGV_ELEMENT_CHILD_INDEX].tagName == "SELECT" &&
								JSVC_STR.VAR_IS_BLANK(DGV_ELEMENT_CHILD[DGV_ELEMENT_CHILD_INDEX].id.toString())
							)
							{
								JSOC_ELEMENT.VAR_INNER_HTML
								(
									DGV_ELEMENT_CHILD[DGV_ELEMENT_CHILD_INDEX], 
									JSOC_ELEMENT.VAR_INNER_HTML("REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB")
								);
							}	
							DGV_ELEMENT_CHILD_INDEX ++;
						}
					}
					
					// Copy items to edit control
					if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB") == true)
					{
						JSOC_CMB.VAR_CLEAR("SEARCH_REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB");
						JSOC_CMB.VAR_ADD("SEARCH_REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB", FLAG_BIGINT_NULL.toString(),"Any Pos_Sale_List");
						JSOC_ELEMENT.VAR_INNER_HTML("SEARCH_REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB", JSOC_ELEMENT.VAR_INNER_HTML("REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB"), true);
						JSOC_CMB.VAR_SELECTED_INDEX("SEARCH_REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB", 0);
						$('.BSSP_SEARCH_REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB').selectpicker('refresh');
					}				
					
					// Update Modal Settings
					if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("POS_RETURN_LIST_MODAL") == true)
					{
						INPUT_INSTANCE = JSOC_WINDOW.VAR_INPUT_INSTANCE_CLONE("POS_RETURN_LIST_MODAL");
					}
					
					// Forward populate complete event.
					$('.BSSP_REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB').selectpicker('refresh');
					HTTP_POPULATE_RESULT();		
				},
				"REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB",
				false, 2
				// , GET_MAP_ARRAY 
			);
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB") == true &&
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB") == false
		)
		{
			JSOC_CMB.VAR_CLEAR("SEARCH_REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB");
			JSOC_CMB.VAR_ADD("SEARCH_REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB", FLAG_BIGINT_NULL.toString(),"Any Pos_Sale_List");
			// To use custom populate
			// var GET_MAP_ARRAY = JSCUS_SQL._RECORD._POS_SALE_LIST.CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			// JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_', JSCUS_SQL._SYSTEM._STATUS.STATUS_ACTIVE);	
			JSCUS_SQL._RECORD._POS_SALE_LIST.CUS_GET_THEN_POPULATE_COMBOBOX
			(
				function()
				{
					// Set Default index
					JSOC_CMB.VAR_SELECTED_INDEX("SEARCH_REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB", 0);
					
					// Forward populate complete event.		
					$('.BSSP_SEARCH_REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB').selectpicker('refresh');
					HTTP_POPULATE_RESULT();
				},		
				"SEARCH_REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB",
				true, 2
				// , GET_MAP_ARRAY 
			);
		}
		
		// Foreign Key [Fixed]
		// _______________________________________________________________________	
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB") == true)
		{
			// Set Default Item, if used in DataGridView
			JSOC_CMB.VAR_ADD("REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB", FLAG_BIGINT_NULL.toString(), "-");
			// To use custom populate
			// var GET_MAP_ARRAY = JSCUS_SQL._CATEGORY._PRODUCT.CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			// JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_', JSCUS_SQL._SYSTEM._STATUS.STATUS_ACTIVE);	
			JSCUS_SQL._CATEGORY._PRODUCT.CUS_GET_THEN_POPULATE_COMBOBOX
			(
				function()
				{
					// Set Default index
					JSOC_CMB.VAR_SELECTED_INDEX("REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB", 0);
					
					// Clone to DGV Cell if ComboBox Exists
					if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("POS_RETURN_LIST_DGV_ROW_REC_POSRETURN_LIST_CAT_PRODUCT_ID") == true)
					{
						DGV_ELEMENT_CHILD = JSOC_ELEMENT.VAR_SUB_ELEMENTS("POS_RETURN_LIST_DGV_ROW_REC_POSRETURN_LIST_CAT_PRODUCT_ID");
						DGV_ELEMENT_CHILD_INDEX = 0;
						while(DGV_ELEMENT_CHILD.length > DGV_ELEMENT_CHILD_INDEX)
						{
							if
							(
								DGV_ELEMENT_CHILD[DGV_ELEMENT_CHILD_INDEX].tagName == "SELECT" &&
								JSVC_STR.VAR_IS_BLANK(DGV_ELEMENT_CHILD[DGV_ELEMENT_CHILD_INDEX].id.toString())
							)
							{
								JSOC_ELEMENT.VAR_INNER_HTML
								(
									DGV_ELEMENT_CHILD[DGV_ELEMENT_CHILD_INDEX], 
									JSOC_ELEMENT.VAR_INNER_HTML("REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB")
								);
							}	
							DGV_ELEMENT_CHILD_INDEX ++;
						}
					}
					
					// Copy items to edit control
					if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB") == true)
					{
						JSOC_CMB.VAR_CLEAR("SEARCH_REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB");
						JSOC_CMB.VAR_ADD("SEARCH_REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB", FLAG_BIGINT_NULL.toString(),"Any Product");
						JSOC_ELEMENT.VAR_INNER_HTML("SEARCH_REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB", JSOC_ELEMENT.VAR_INNER_HTML("REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB"), true);
						JSOC_CMB.VAR_SELECTED_INDEX("SEARCH_REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB", 0);
						$('.BSSP_SEARCH_REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB').selectpicker('refresh');
					}				
					
					// Update Modal Settings
					if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("POS_RETURN_LIST_MODAL") == true)
					{
						INPUT_INSTANCE = JSOC_WINDOW.VAR_INPUT_INSTANCE_CLONE("POS_RETURN_LIST_MODAL");
					}
					
					// Forward populate complete event.
					$('.BSSP_REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB').selectpicker('refresh');
					HTTP_POPULATE_RESULT();		
				},
				"REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB",
				false, 2
				// , GET_MAP_ARRAY 
			);
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB") == true &&
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB") == false
		)
		{
			JSOC_CMB.VAR_CLEAR("SEARCH_REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB");
			JSOC_CMB.VAR_ADD("SEARCH_REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB", FLAG_BIGINT_NULL.toString(),"Any Product");
			// To use custom populate
			// var GET_MAP_ARRAY = JSCUS_SQL._CATEGORY._PRODUCT.CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			// JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_', JSCUS_SQL._SYSTEM._STATUS.STATUS_ACTIVE);	
			JSCUS_SQL._CATEGORY._PRODUCT.CUS_GET_THEN_POPULATE_COMBOBOX
			(
				function()
				{
					// Set Default index
					JSOC_CMB.VAR_SELECTED_INDEX("SEARCH_REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB", 0);
					
					// Forward populate complete event.		
					$('.BSSP_SEARCH_REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB').selectpicker('refresh');
					HTTP_POPULATE_RESULT();
				},		
				"SEARCH_REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB",
				true, 2
				// , GET_MAP_ARRAY 
			);
		}
		
		// Foreign Key [Fixed]
		// _______________________________________________________________________	
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("REC_POSRETURN_LIST_CAT_UOM_ID_CMB") == true)
		{
			// Set Default Item, if used in DataGridView
			JSOC_CMB.VAR_ADD("REC_POSRETURN_LIST_CAT_UOM_ID_CMB", FLAG_BIGINT_NULL.toString(), "-");
			// To use custom populate
			// var GET_MAP_ARRAY = JSCUS_SQL._CATEGORY._UNIT.CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			// JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_', JSCUS_SQL._SYSTEM._STATUS.STATUS_ACTIVE);	
			JSCUS_SQL._CATEGORY._UNIT.CUS_GET_THEN_POPULATE_COMBOBOX
			(
				function()
				{
					// Set Default index
					JSOC_CMB.VAR_SELECTED_INDEX("REC_POSRETURN_LIST_CAT_UOM_ID_CMB", 0);
					
					// Clone to DGV Cell if ComboBox Exists
					if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("POS_RETURN_LIST_DGV_ROW_REC_POSRETURN_LIST_CAT_UOM_ID") == true)
					{
						DGV_ELEMENT_CHILD = JSOC_ELEMENT.VAR_SUB_ELEMENTS("POS_RETURN_LIST_DGV_ROW_REC_POSRETURN_LIST_CAT_UOM_ID");
						DGV_ELEMENT_CHILD_INDEX = 0;
						while(DGV_ELEMENT_CHILD.length > DGV_ELEMENT_CHILD_INDEX)
						{
							if
							(
								DGV_ELEMENT_CHILD[DGV_ELEMENT_CHILD_INDEX].tagName == "SELECT" &&
								JSVC_STR.VAR_IS_BLANK(DGV_ELEMENT_CHILD[DGV_ELEMENT_CHILD_INDEX].id.toString())
							)
							{
								JSOC_ELEMENT.VAR_INNER_HTML
								(
									DGV_ELEMENT_CHILD[DGV_ELEMENT_CHILD_INDEX], 
									JSOC_ELEMENT.VAR_INNER_HTML("REC_POSRETURN_LIST_CAT_UOM_ID_CMB")
								);
							}	
							DGV_ELEMENT_CHILD_INDEX ++;
						}
					}
					
					// Copy items to edit control
					if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_CAT_UOM_ID_CMB") == true)
					{
						JSOC_CMB.VAR_CLEAR("SEARCH_REC_POSRETURN_LIST_CAT_UOM_ID_CMB");
						JSOC_CMB.VAR_ADD("SEARCH_REC_POSRETURN_LIST_CAT_UOM_ID_CMB", FLAG_BIGINT_NULL.toString(),"Any Unit");
						JSOC_ELEMENT.VAR_INNER_HTML("SEARCH_REC_POSRETURN_LIST_CAT_UOM_ID_CMB", JSOC_ELEMENT.VAR_INNER_HTML("REC_POSRETURN_LIST_CAT_UOM_ID_CMB"), true);
						JSOC_CMB.VAR_SELECTED_INDEX("SEARCH_REC_POSRETURN_LIST_CAT_UOM_ID_CMB", 0);
						$('.BSSP_SEARCH_REC_POSRETURN_LIST_CAT_UOM_ID_CMB').selectpicker('refresh');
					}				
					
					// Update Modal Settings
					if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("POS_RETURN_LIST_MODAL") == true)
					{
						INPUT_INSTANCE = JSOC_WINDOW.VAR_INPUT_INSTANCE_CLONE("POS_RETURN_LIST_MODAL");
					}
					
					// Forward populate complete event.
					$('.BSSP_REC_POSRETURN_LIST_CAT_UOM_ID_CMB').selectpicker('refresh');
					HTTP_POPULATE_RESULT();		
				},
				"REC_POSRETURN_LIST_CAT_UOM_ID_CMB",
				false, 2
				// , GET_MAP_ARRAY 
			);
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_CAT_UOM_ID_CMB") == true &&
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("REC_POSRETURN_LIST_CAT_UOM_ID_CMB") == false
		)
		{
			JSOC_CMB.VAR_CLEAR("SEARCH_REC_POSRETURN_LIST_CAT_UOM_ID_CMB");
			JSOC_CMB.VAR_ADD("SEARCH_REC_POSRETURN_LIST_CAT_UOM_ID_CMB", FLAG_BIGINT_NULL.toString(),"Any Unit");
			// To use custom populate
			// var GET_MAP_ARRAY = JSCUS_SQL._CATEGORY._UNIT.CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			// JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_', JSCUS_SQL._SYSTEM._STATUS.STATUS_ACTIVE);	
			JSCUS_SQL._CATEGORY._UNIT.CUS_GET_THEN_POPULATE_COMBOBOX
			(
				function()
				{
					// Set Default index
					JSOC_CMB.VAR_SELECTED_INDEX("SEARCH_REC_POSRETURN_LIST_CAT_UOM_ID_CMB", 0);
					
					// Forward populate complete event.		
					$('.BSSP_SEARCH_REC_POSRETURN_LIST_CAT_UOM_ID_CMB').selectpicker('refresh');
					HTTP_POPULATE_RESULT();
				},		
				"SEARCH_REC_POSRETURN_LIST_CAT_UOM_ID_CMB",
				true, 2
				// , GET_MAP_ARRAY 
			);
		}
		
		// Foreign Key [Fixed]
		// _______________________________________________________________________	
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB") == true)
		{
			// Set Default Item, if used in DataGridView
			JSOC_CMB.VAR_ADD("REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB", FLAG_BIGINT_NULL.toString(), "-");
			// To use custom populate
			// var GET_MAP_ARRAY = JSCUS_SQL._CATEGORY._DISCOUNT.CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			// JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_', JSCUS_SQL._SYSTEM._STATUS.STATUS_ACTIVE);	
			JSCUS_SQL._CATEGORY._DISCOUNT.CUS_GET_THEN_POPULATE_COMBOBOX
			(
				function()
				{
					// Set Default index
					JSOC_CMB.VAR_SELECTED_INDEX("REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB", 0);
					
					// Clone to DGV Cell if ComboBox Exists
					if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("POS_RETURN_LIST_DGV_ROW_REC_POSRETURN_LIST_CAT_DISCOUNT_ID") == true)
					{
						DGV_ELEMENT_CHILD = JSOC_ELEMENT.VAR_SUB_ELEMENTS("POS_RETURN_LIST_DGV_ROW_REC_POSRETURN_LIST_CAT_DISCOUNT_ID");
						DGV_ELEMENT_CHILD_INDEX = 0;
						while(DGV_ELEMENT_CHILD.length > DGV_ELEMENT_CHILD_INDEX)
						{
							if
							(
								DGV_ELEMENT_CHILD[DGV_ELEMENT_CHILD_INDEX].tagName == "SELECT" &&
								JSVC_STR.VAR_IS_BLANK(DGV_ELEMENT_CHILD[DGV_ELEMENT_CHILD_INDEX].id.toString())
							)
							{
								JSOC_ELEMENT.VAR_INNER_HTML
								(
									DGV_ELEMENT_CHILD[DGV_ELEMENT_CHILD_INDEX], 
									JSOC_ELEMENT.VAR_INNER_HTML("REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB")
								);
							}	
							DGV_ELEMENT_CHILD_INDEX ++;
						}
					}
					
					// Copy items to edit control
					if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB") == true)
					{
						JSOC_CMB.VAR_CLEAR("SEARCH_REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB");
						JSOC_CMB.VAR_ADD("SEARCH_REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB", FLAG_BIGINT_NULL.toString(),"Any Discount");
						JSOC_ELEMENT.VAR_INNER_HTML("SEARCH_REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB", JSOC_ELEMENT.VAR_INNER_HTML("REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB"), true);
						JSOC_CMB.VAR_SELECTED_INDEX("SEARCH_REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB", 0);
						$('.BSSP_SEARCH_REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB').selectpicker('refresh');
					}				
					
					// Update Modal Settings
					if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("POS_RETURN_LIST_MODAL") == true)
					{
						INPUT_INSTANCE = JSOC_WINDOW.VAR_INPUT_INSTANCE_CLONE("POS_RETURN_LIST_MODAL");
					}
					
					// Forward populate complete event.
					$('.BSSP_REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB').selectpicker('refresh');
					HTTP_POPULATE_RESULT();		
				},
				"REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB",
				false, 2
				// , GET_MAP_ARRAY 
			);
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB") == true &&
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB") == false
		)
		{
			JSOC_CMB.VAR_CLEAR("SEARCH_REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB");
			JSOC_CMB.VAR_ADD("SEARCH_REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB", FLAG_BIGINT_NULL.toString(),"Any Discount");
			// To use custom populate
			// var GET_MAP_ARRAY = JSCUS_SQL._CATEGORY._DISCOUNT.CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			// JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_', JSCUS_SQL._SYSTEM._STATUS.STATUS_ACTIVE);	
			JSCUS_SQL._CATEGORY._DISCOUNT.CUS_GET_THEN_POPULATE_COMBOBOX
			(
				function()
				{
					// Set Default index
					JSOC_CMB.VAR_SELECTED_INDEX("SEARCH_REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB", 0);
					
					// Forward populate complete event.		
					$('.BSSP_SEARCH_REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB').selectpicker('refresh');
					HTTP_POPULATE_RESULT();
				},		
				"SEARCH_REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB",
				true, 2
				// , GET_MAP_ARRAY 
			);
		}
		
		// Status		
		// _______________________________________________________________________	
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_STATUS_CMB") == true)
		{
			JSOC_CMB.VAR_CLEAR("SEARCH_REC_POSRETURN_LIST_STATUS_CMB");
			JSOC_CMB.VAR_ADD("SEARCH_REC_POSRETURN_LIST_STATUS_CMB", "0","Any Status");
			JSOC_CMB.VAR_ADD("SEARCH_REC_POSRETURN_LIST_STATUS_CMB", "1","Inactive");
			JSOC_CMB.VAR_ADD("SEARCH_REC_POSRETURN_LIST_STATUS_CMB", "2","Active");
			// JSOC_CMB.VAR_ADD("SEARCH_REC_POSRETURN_LIST_STATUS_CMB", "3","Closed");
			// JSOC_CMB.VAR_ADD("SEARCH_REC_POSRETURN_LIST_STATUS_CMB", "4","Completed");
			JSOC_CMB.VAR_SELECTED_VALUE("SEARCH_REC_POSRETURN_LIST_STATUS_CMB", "2");
		}			
		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("REC_POSRETURN_LIST_STATUS_CMB") == true)
		{
			JSOC_CMB.VAR_CLEAR("REC_POSRETURN_LIST_STATUS_CMB");
			JSOC_CMB.VAR_ADD("REC_POSRETURN_LIST_STATUS_CMB", "1","Inactive");
			JSOC_CMB.VAR_ADD("REC_POSRETURN_LIST_STATUS_CMB", "2","Active");
			// JSOC_CMB.VAR_ADD("REC_POSRETURN_LIST_STATUS_CMB", "3","Closed");
			// JSOC_CMB.VAR_ADD("REC_POSRETURN_LIST_STATUS_CMB", "4","Completed");
			JSOC_CMB.VAR_SELECTED_VALUE("REC_POSRETURN_LIST_STATUS_CMB", "2");
		}
		
		
		
		// Get Modal Instance (Add Modal Adjustment before this line)
		// _______________________________________________________________________	
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("POS_RETURN_LIST_MODAL") == true)
		{
			INPUT_INSTANCE = JSOC_WINDOW.VAR_INPUT_INSTANCE_CLONE("POS_RETURN_LIST_MODAL");
		}
		
		// Add Search Events for the SEARCH_DESCRIPTION_TXT - TextInput
		// _______________________________________________________________________		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_ID_TXT"))
		{
			var SEARCH_REC_POSRETURN_LIST_ID_TXT = JSOC_ELEMENT.VAR_GET("SEARCH_REC_POSRETURN_LIST_ID_TXT");
			SEARCH_REC_POSRETURN_LIST_ID_TXT.onkeydown = 
				function() 
				{ 
					return function(e) 
					{
						if
						(
							(
								e.which == 13 || 
								e.keyCode == 13 || 
								e.key === "Enter"
							) &&
							JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_CMD")
						)
						{
							HTTP_SEARCH();
						}
					};
				}();;		
		}
		
		
		// Load Parent Data (if Exists)
		// _______________________________________________________________________	
		HTTP_PARENT_LOAD();
		
		
		// Pre-Load Items (uncomment if no foreign key pre-fetch)
		// _______________________________________________________________________	
		if(CUS_SEND_REQUEST_HAS_QUEUE() == false)
		{
			HTTP_SEARCH();
		}
		
		
		// Disable Dialogs
		// _______________________________________________________________________	
		CUS_SEND_DIALOG_TRY_DISMISS();
	}
	
	
	// ===============================================================
	// Populate Foreign Keys
	// ===============================================================
	function HTTP_POPULATE_RESULT(IS_SUCCESS, HTTP_RESPONSE)
	{
		// Disable Dialogs
		CUS_SEND_DIALOG_TRY_DISMISS();
			
		// Handle Error
		if(IS_SUCCESS === false)
		{
			alert("Unable to populate lists.");
		}
		else
		{
			// Disable Dialogs
			if(CUS_SEND_REQUEST_HAS_QUEUE() == false)
			{
				HTTP_SEARCH();
			}
		}
	}

	
	// ===============================================================
	// Request Search - PART.A
	// ===============================================================
	function HTTP_SEARCH(NEW_ITEM_ID, EDITED_ROW_INDEX)
	{
		// Optional Value
		NEW_ITEM_ID = JSVC_VAR.VAR_OPTIONAL(NEW_ITEM_ID, -1);
		EDITED_ROW_INDEX = JSVC_VAR.VAR_OPTIONAL(EDITED_ROW_INDEX, -1);
		
		// Parameter Validate
		JSVC_AV.VAR_VALIDATE_ARGUMENT_TYPE(NEW_ITEM_ID, 'NEW_ITEM_ID', 'NUMERIC');
		JSVC_AV.VAR_VALIDATE_ARGUMENT_TYPE(EDITED_ROW_INDEX, 'EDITED_ROW_INDEX', 'NUMERIC');
		
		
		// Actual Function
		GET_MAP_ARRAY = JSCUS_SQL._RECORD._POS_RETURN_LIST.CUS_PREPARE_MAPPED_ARRAY_FOR_GET();	
		//  if(JSVC_VAR.VAR_ISSET("PROPERTY_PARENT_ID"))
		// {
		//	JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_PARENT_ID', PROPERTY_PARENT_ID);
		// }  // Parent ID Sample
		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB") == true)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_REC_POSRETURN_ID', JSVC_NUM.VAR_NVAL(JSOC_CMB.VAR_SELECTED_VALUE("SEARCH_REC_POSRETURN_LIST_REC_POSRETURN_ID_CMB")));
		}
		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB") == true)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_REC_POSSALE_LIST_ID', JSVC_NUM.VAR_NVAL(JSOC_CMB.VAR_SELECTED_VALUE("SEARCH_REC_POSRETURN_LIST_REC_POSSALE_LIST_ID_CMB")));
		}
		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB") == true)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_CAT_PRODUCT_ID', JSVC_NUM.VAR_NVAL(JSOC_CMB.VAR_SELECTED_VALUE("SEARCH_REC_POSRETURN_LIST_CAT_PRODUCT_ID_CMB")));
		}
		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_CAT_UOM_ID_CMB") == true)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_CAT_UOM_ID', JSVC_NUM.VAR_NVAL(JSOC_CMB.VAR_SELECTED_VALUE("SEARCH_REC_POSRETURN_LIST_CAT_UOM_ID_CMB")));
		}
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_AMOUNT_PRICE_FROM_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_AMOUNT_PRICE_FROM_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_AMOUNT_PRICE_FROM', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_AMOUNT_PRICE_FROM_TXT")));
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_AMOUNT_PRICE_TO_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_AMOUNT_PRICE_TO_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_AMOUNT_PRICE_TO', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_AMOUNT_PRICE_TO_TXT")));
		}			
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_AMOUNT_COST_FROM_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_AMOUNT_COST_FROM_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_AMOUNT_COST_FROM', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_AMOUNT_COST_FROM_TXT")));
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_AMOUNT_COST_TO_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_AMOUNT_COST_TO_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_AMOUNT_COST_TO', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_AMOUNT_COST_TO_TXT")));
		}			
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_AMOUNT_VAT_FROM_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_AMOUNT_VAT_FROM_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_AMOUNT_VAT_FROM', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_AMOUNT_VAT_FROM_TXT")));
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_AMOUNT_VAT_TO_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_AMOUNT_VAT_TO_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_AMOUNT_VAT_TO', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_AMOUNT_VAT_TO_TXT")));
		}			
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_QUANTITY_FROM_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_QUANTITY_FROM_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_QUANTITY_FROM', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_QUANTITY_FROM_TXT")));
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_QUANTITY_TO_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_QUANTITY_TO_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_QUANTITY_TO', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_QUANTITY_TO_TXT")));
		}			
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_QUANTITY_PCS_FROM_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_QUANTITY_PCS_FROM_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_QUANTITY_PCS_FROM', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_QUANTITY_PCS_FROM_TXT")));
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_QUANTITY_PCS_TO_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_QUANTITY_PCS_TO_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_QUANTITY_PCS_TO', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_QUANTITY_PCS_TO_TXT")));
		}			
		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB") == true)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_CAT_DISCOUNT_ID', JSVC_NUM.VAR_NVAL(JSOC_CMB.VAR_SELECTED_VALUE("SEARCH_REC_POSRETURN_LIST_CAT_DISCOUNT_ID_CMB")));
		}
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_TORTN_SUBTOTAL_FROM_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_TORTN_SUBTOTAL_FROM_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_TORTN_SUBTOTAL_FROM', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_TORTN_SUBTOTAL_FROM_TXT")));
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_TORTN_SUBTOTAL_TO_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_TORTN_SUBTOTAL_TO_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_TORTN_SUBTOTAL_TO', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_TORTN_SUBTOTAL_TO_TXT")));
		}			
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_TORTN_DISCOUNT_FROM_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_TORTN_DISCOUNT_FROM_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_TORTN_DISCOUNT_FROM', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_TORTN_DISCOUNT_FROM_TXT")));
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_TORTN_DISCOUNT_TO_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_TORTN_DISCOUNT_TO_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_TORTN_DISCOUNT_TO', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_TORTN_DISCOUNT_TO_TXT")));
		}			
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_TORTN_VATABLE_FROM_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_TORTN_VATABLE_FROM_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_TORTN_VATABLE_FROM', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_TORTN_VATABLE_FROM_TXT")));
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_TORTN_VATABLE_TO_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_TORTN_VATABLE_TO_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_TORTN_VATABLE_TO', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_TORTN_VATABLE_TO_TXT")));
		}			
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_TORTN_VATEXEMPT_FROM_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_TORTN_VATEXEMPT_FROM_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_TORTN_VATEXEMPT_FROM', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_TORTN_VATEXEMPT_FROM_TXT")));
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_TORTN_VATEXEMPT_TO_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_TORTN_VATEXEMPT_TO_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_TORTN_VATEXEMPT_TO', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_TORTN_VATEXEMPT_TO_TXT")));
		}			
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_TORTN_NONVAT_FROM_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_TORTN_NONVAT_FROM_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_TORTN_NONVAT_FROM', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_TORTN_NONVAT_FROM_TXT")));
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_TORTN_NONVAT_TO_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_TORTN_NONVAT_TO_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_TORTN_NONVAT_TO', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_TORTN_NONVAT_TO_TXT")));
		}			
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_TORTN_ZERORATED_FROM_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_TORTN_ZERORATED_FROM_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_TORTN_ZERORATED_FROM', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_TORTN_ZERORATED_FROM_TXT")));
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_TORTN_ZERORATED_TO_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_TORTN_ZERORATED_TO_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_TORTN_ZERORATED_TO', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_TORTN_ZERORATED_TO_TXT")));
		}			
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_TORTN_VATOTHER_FROM_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_TORTN_VATOTHER_FROM_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_TORTN_VATOTHER_FROM', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_TORTN_VATOTHER_FROM_TXT")));
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_TORTN_VATOTHER_TO_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_TORTN_VATOTHER_TO_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_TORTN_VATOTHER_TO', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_TORTN_VATOTHER_TO_TXT")));
		}			
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_TORTN_VAT_FROM_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_TORTN_VAT_FROM_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_TORTN_VAT_FROM', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_TORTN_VAT_FROM_TXT")));
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_TORTN_VAT_TO_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_TORTN_VAT_TO_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_TORTN_VAT_TO', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_TORTN_VAT_TO_TXT")));
		}			
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_TORTN_VAT_LESS_FROM_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_TORTN_VAT_LESS_FROM_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_TORTN_VAT_LESS_FROM', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_TORTN_VAT_LESS_FROM_TXT")));
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_TORTN_VAT_LESS_TO_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_TORTN_VAT_LESS_TO_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_TORTN_VAT_LESS_TO', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_TORTN_VAT_LESS_TO_TXT")));
		}			
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_POINTS_FROM_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_POINTS_FROM_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_POINTS_FROM', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_POINTS_FROM_TXT")));
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_POINTS_TO_TXT") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_REC_POSRETURN_LIST_POINTS_TO_TXT') == true
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_POINTS_TO', JSVC_NUM.VAR_NVAL(JSOC_ELEMENT.VAR_VALUE("SEARCH_REC_POSRETURN_LIST_POINTS_TO_TXT")));
		}			
		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_REC_POSRETURN_LIST_STATUS_CMB") == true)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_STATUS', JSVC_NUM.VAR_NVAL(JSOC_CMB.VAR_SELECTED_VALUE("SEARCH_REC_POSRETURN_LIST_STATUS_CMB")));
		}
		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_ORDER_BY_CMB") == true)
		{
			var SELECTED_VAL = JSOC_CMB.VAR_SELECTED_VALUE("SEARCH_ORDER_BY_CMB");
			if(JSVC_STR.VAR_CONTAINS_RIGHT(SELECTED_VAL, '_ASC'))
			{
				JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ORDER_FIELD', JSVC_STR.VAR_DRIGHT(SELECTED_VAL, 4));
				JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ORDER_TYPE', 'ASC');		
			}
			else
			{
				JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ORDER_FIELD', SELECTED_VAL);
				JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ORDER_TYPE', 'DESC');
			}
		}	
		
		JSOC_DIALOG.VAR_LOADING_SPINNER(true);
		
		if(NEW_ITEM_ID < 0)
		{
			JSCUS_SQL._RECORD._POS_RETURN_LIST.CUS_GET
			(
				GET_MAP_ARRAY,
				HTTP_SEARCH_CALLBACK,
				true
			); 		
		}
		else
		{		
			GET_MAP_ARRAY = JSCUS_SQL._RECORD._POS_RETURN_LIST.CUS_PREPARE_MAPPED_ARRAY_FOR_GET();	
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_REC_POSRETURN_LIST_ID', NEW_ITEM_ID);
			
			JSCUS_SQL._RECORD._POS_RETURN_LIST.CUS_GET
			(
				GET_MAP_ARRAY,
				function(IS_SUCCESS, RESPONSE_STRING)
				{
					// Update Existing Row
					if(EDITED_ROW_INDEX >= 0)
					{
						HTTP_SEARCH_LIMITED_ROWS_CALLBACK(IS_SUCCESS, RESPONSE_STRING, EDITED_ROW_INDEX);
					}
					
					// Add new item
					else
					{
						HTTP_SEARCH_LIMITED_ROWS_CALLBACK(IS_SUCCESS, RESPONSE_STRING, 0);
					}
				},
				true
			); 		
		}
       		
	}
	
	
	// ===============================================================
	// Request Search - PART.B
	// ===============================================================
	function HTTP_SEARCH_CALLBACK(IS_SUCCESS, RESPONSE_STRING)
	{
		// Disable Dialogs
		// _______________________________________________________________________
		CUS_SEND_DIALOG_TRY_DISMISS();
		
		// Validate
		// _______________________________________________________________________
		if(IS_SUCCESS === false)
		{
			console.error("CONNECTION ERROR: \n" + RESPONSE_STRING);
			return;
		}
		
		// Validate JSON Response
		// _______________________________________________________________________
		var JSON_OBJECT = JSRC_JSON.REF_CREATE(RESPONSE_STRING);
		if(JSRC_JSON.REF_IS_SUCCESS(JSON_OBJECT) === false)
		{
			console.error("REQUEST ERROR: \n" + RESPONSE_STRING);
			return;
		}
		
		// JSON Empty (Clears the DataGrodView)
		// _______________________________________________________________________
		if(JSRC_JSON.REF_READ(JSON_OBJECT, "JSON_COUNT") <= 0)
		{
			POS_RETURN_LIST_DGV.ROW.CLEAR();
			return;
		}

		// Populate DGV
		// _______________________________________________________________________
		POS_RETURN_LIST_DGV.POPULATE_FROM_QUERY
		(
				JSON_OBJECT, 
				'',
				false,
				false,
				1,
				[2, 1]
		);
		
		
		// For Applying CFormat
		// _______________________________________________________________________	
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_AMOUNT_PRICE");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_AMOUNT_COST");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_AMOUNT_VAT");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_QUANTITY");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_QUANTITY_PCS");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_TORTN_SUBTOTAL");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_TORTN_DISCOUNT");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_TORTN_VATABLE");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_TORTN_VATEXEMPT");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_TORTN_NONVAT");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_TORTN_ZERORATED");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_TORTN_VATOTHER");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_TORTN_VAT");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_TORTN_VAT_LESS");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_POINTS");
		
		
		// Initialize
		// _______________________________________________________________________	
		var WEBTABLE_DATE = null;
		var ROW_INDEX = 0;
	
	
		// DateTime Format
		// _______________________________________________________________________	

	}
	
	
	// ===============================================================
	// Request Search - PART.C
	// ===============================================================
	function HTTP_SEARCH_LIMITED_ROWS_CALLBACK(IS_SUCCESS, RESPONSE_STRING, ROW_INDEX)
	{
		// Disable Dialogs
		// _______________________________________________________________________
		CUS_SEND_DIALOG_TRY_DISMISS();
		
		// Validate
		// _______________________________________________________________________
		if(IS_SUCCESS === false)
		{
			console.error("CONNECTION ERROR: \n" + RESPONSE_STRING);
			return;
		}
		
		// Validate JSON Response
		// _______________________________________________________________________
		var JSON_OBJECT = JSRC_JSON.REF_CREATE(RESPONSE_STRING);
		if(JSRC_JSON.REF_IS_SUCCESS(JSON_OBJECT) === false)
		{
			console.error("REQUEST ERROR: \n" + RESPONSE_STRING);
			return;
		}
		
		// JSON Empty (Clears the DataGrodView)
		// _______________________________________________________________________
		if(JSRC_JSON.REF_READ(JSON_OBJECT, "JSON_COUNT") <= 0)
		{
			POS_RETURN_LIST_DGV.ROW.CLEAR();
			return;
		}

		// Validate Row Count
		// _______________________________________________________________________	
		if(POS_RETURN_LIST_DGV.ROW.COUNT() <= 0)
		{
			console.error("DataGridView has no rows to fill.");
			return;
		}
		JSVC_AV.VAR_VALIDATE_RANGE(ROW_INDEX, "ROW_INDEX", 0, POS_RETURN_LIST_DGV.ROW.COUNT() - 1);
		
		// Populate DGV
		// _______________________________________________________________________
		POS_RETURN_LIST_DGV.POPULATE_FROM_QUERY
		(
				JSON_OBJECT, 
				'',
				false,
				false,
				1,
				[2, 1],
				ROW_INDEX
		);
		
		
		// For Applying CFormat
		// _______________________________________________________________________	
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_AMOUNT_PRICE");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_AMOUNT_COST");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_AMOUNT_VAT");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_QUANTITY");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_QUANTITY_PCS");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_TORTN_SUBTOTAL");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_TORTN_DISCOUNT");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_TORTN_VATABLE");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_TORTN_VATEXEMPT");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_TORTN_NONVAT");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_TORTN_ZERORATED");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_TORTN_VATOTHER");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_TORTN_VAT");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_TORTN_VAT_LESS");
		POS_RETURN_LIST_DGV.COLUMN.CFORMAT("REC_POSRETURN_LIST_POINTS");
		
		
		// Initialize
		// _______________________________________________________________________	
		var WEBTABLE_DATE = null;
	
	
		// DateTime Format
		// _______________________________________________________________________	

	}
	
				
	// ===============================================================
	// Begin Processing the Page
	// ===============================================================
	FORM_INITIALIZE();
	FORM_LOAD();